<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1.0"/>
<style>
#GameArea {
    border:1px solid #d3d3d3;
    background-color: #f1f1f1;
}
</style>
</head>
<body>
	<canvas id="GameArea" width="500px" height="500px"></canvas>
	<br>
	<button onclick="StartFun()">Start</button>
	<button onclick="StopFun()">Pause</button>
	<select id="level">
		<option value="1">level 1</option>
		<option value="2">level 2</option>
		<option value="3">level 3</option>
	</select>
	<select id="board">
		<option value="1">grey</option>
		<option value="2">black</option>
		<option value="3">blue</option>
	</select>

	<script>
		var noofcomp;
		var interval;
		var canvas=document.getElementById("GameArea");
		var ctx=canvas.getContext("2d");
		var comph=10;
		var compy=10;

		//Creating blocks of snake
		function StartGame(x,y){
			ctx.fillStyle="red";
			ctx.fillRect(x*comph,y*compy,10,10);
			ctx.fillStyle="black";
			ctx.strokeRect(x*comph,y*compy,10,10);
		}

		var comp=[];
		noofcomp=4;
		//inital snake of noofcomp blocks
		for (var n=noofcomp-1; n>=0; n--){
			comp.push({x:n,y:0});
		}

		//action listener for key pressed
		var dir="right";
		document.addEventListener("keydown",dirContral);
		function dirContral(e){
			if(e.keyCode==37 && dir!="right"){
				dir="left";
			}
			else if(e.keyCode==38 && dir!="down"){
				dir="up";
			}
			else if(e.keyCode==39 && dir!="left"){
				dir="right";
			}
			else if(e.keyCode==40 && dir!="up"){
				dir="down";
			}
		}
		
		//variable for block location coordinates and placing the block
		var block={x:Math.round(Math.random()*(canvas.width/10-1)+1),y:Math.round(Math.random()*(canvas.height/10-1)+1)};
		function Block_placement(x,y){
			ctx.fillStyle="green";
			ctx.fillRect(x*comph,y*compy,10,10);
			ctx.fillStyle="black";
			ctx.strokeRect(x*comph,y*compy,10,10);
		}
		
		//game logic
		function move_comp(){
			ctx.clearRect(0,0,500,500);
			headx++;
			//creating snake
			for (var r = 0; r < comp.length; r++) {

				StartGame(comp[r].x,comp[r].y);
			}
			var headx=comp[0].x;
			var heady=comp[0].y;
			//placing block
			Block_placement(block.x,block.y);
			//direction of snake
			if(dir=="left"){
				headx--;
			}
			else if(dir=="right"){
				headx++;
			}
			else if(dir=="up"){
				heady--;
			}
			else if(dir=="down"){
				heady++;
			}
			//head meets block 
			if(headx==block.x && heady==block.y){
				block={x:Math.round(Math.random()*(canvas.width/10-1)+1),y:Math.round(Math.random()*(canvas.height/10-1)+1)};
				Block_placement(block.x,block.y);
				new_head={x:headx,y:heady}
			}
			else{
				comp.pop();
				new_head={x:headx,y:heady}
				
			}
			//snake hit itself
			for(var j=1; j<comp.length; j++){
				if(headx==comp[j].x && heady==comp[j].y){
					myStopFunction(comp.length);	
				}
			}
			comp.unshift(new_head);
			//snake hit wall
			if(headx<0 || heady<0 || headx>=51 || heady>=51){
				myStopFunction(comp.length);
			}
			
		}
		var myvar;
		function StartFun(){
			var level=document.getElementById("level").value;
			if(level=="1"){
				interval=500;
			}
			else if(level=="2"){
				interval=300;
			}
			else if(level=="3"){
				interval=100;
			}
			var boardC=document.getElementById("board").value;
			var board=document.getElementById("GameArea");
			if(boardC=="1"){
				board.style.backgroundColor="grey";
			}
			else if(boardC=="2"){
				board.style.backgroundColor="black";
			}
			else if(boardC=="3"){
				board.style.backgroundColor="blue";
			}		
			myvar=setInterval(move_comp,interval);
		}
		//pause game
		function StopFun(){
			clearInterval(myvar);
    		alert("Game paused");
		}
		//game over
		function myStopFunction(score) {
    		clearInterval(myvar);
    		alert("Game Over...!!!!! Your score is "+score);
		}
	</script>
</body><!----body completed-->
</html>